Subject: Re: ICMP packets - ll_temac with Microblaze

From: Michal Simek <[email-masked]>
Date: Wed, 21 Dec 2011 11:41:40 +0100

Eric Dumazet wrote:
> Le mercredi 21 décembre 2011 à 11:32 +0100, Michal Simek a écrit :
>> Eric Dumazet wrote:
>>> Le mercredi 21 décembre 2011 à 11:28 +0100, Eric Dumazet a écrit :
>>>> Le mercredi 21 décembre 2011 à 11:11 +0100, Michal Simek a écrit :
>>>>> Hi Eric and David,
>>>>>
>>>>> I have found one problem with ll_temac driver and
>>>>> this commit: net: more accurate skb truesize
>>>>> sha1: 87fb4b7b533073eeeaed0b6bf7c2328995f6c075
>>>>>
>>>>> The problem is only with icmp packets from the target. It is sent and driver receive it
>>>>> but it is not proceed to the application.
>>>>>
>>>>> The problem I see is that kmalloc_node_track_caller allocate
>>>>> specific size and then this size is changed by SKB_WITH_OVERHEAD(ksize(data)).
>>>>> The problem is with netdev_alloc_skb_ip_align which calls __alloc_skb function.
>>>>>
>>>>> Currently driver uses setting for jumbo frames (9k). When I change it to use mtu (1,5k) then
>>>>> everything is ok.
>>>>>
>>>>> Can you give me some hints what can be wrong?
>>>>>
>>>> Is it with SLUB, SLAB or SLOB allocator ?
>>>>
>>>>
>>> (I am referring to commit bc417e30f8d
>>> (net: Add back alignment for size for __alloc_skb)
>> I have seen that commit. Using the latest&greatest version with this patch.
>>
> 
> So after these changes, struct skb_shared_info is located to the very
> end of allocated memory.
> 
> Maybe there is a problem with MTU=9000, since assuming PAGE_SIZE=4096 on
> your machine (is it ?), we have a 16384 bytes block of memory, and
> ~16000 available in skb head, instead of ~9000

yes, page size is 4k.

Here is the log for allocation - origin size for MTU 9000 is 0x2420(9248) and size after
overhead is 0x3f40(16192)

kmalloc_node_track_caller size 00002420, SKB_WITH_OVERHEAD(ksize(data)) 00003f40
skb->head     c7870000
skb->data     c7870000
skb->tail     c7870000
skb->truesize 000040c0
skb->end      c7873f40

Michal

-- 
Michal Simek, Ing. (M.Eng)
w: www.monstr.eu p: +42-0-721842854
Maintainer of Linux kernel 2.6 Microblaze Linux - http://www.monstr.eu/fdt/
Microblaze U-BOOT custodian